



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU 1300 Pearls （DP）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU 1300 Pearls （DP）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 17:52:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>题目链接：</strong><a href="http://acm.hdu.edu.cn/showproblem.php?pid=1300" rel="external nofollow noreferrer">http://acm.hdu.edu.cn/showproblem.php?pid=1300</a></p>
<p><strong>题目大意：</strong>珠宝店有100种不同质量的珍珠，质量越高价钱越高，为了促进销售，每买一种类型的珍珠，要在原来的基础上必须再买10个。这时一个CFO发现，这种条件下，有时买质量更好的反而更便宜。比如要买10元的珍珠5个，20元的珍珠100个，普通的买法需要(5+10)*10 + (100+10)*20 = 2350，但是如果只买105个价值20元的珍珠，只需要&nbsp;(5+100+10)*20 = 2300。现在给定要买的珍珠的数量和对应价格，求最少花费</p>
<div><strong>Sample Input</strong></div>
<div>
<div>2</div>
<div>2</div>
<div>100 1</div>
<div>100 2</div>
<div>3</div>
<div>1 10</div>
<div>1 11</div>
<div>100 12</div>
</div>
<div>&nbsp;</div>
<div><strong>Sample Output</strong></div>
<div>
<div>330</div>
<div>1344</div>
<div>&nbsp;</div>
</div>
<p><strong>分析：</strong>令dp[i]表示买前 i 种珍珠的最小花费，则dp[i] = min{dp[j],(珍珠 j 到珍珠 i 的数量)*珍珠 i 的价值 | j&lt;i}</p>
<p><strong>代码如下：</strong></p>
<div>
<pre class="prettyprint linenums"> # include&lt;iostream&gt;<br />
 # include&lt;cstdio&gt;<br />
 # include&lt;cstring&gt;<br />
 # define maxn<br />
 # define inf   //这个大小要合适，不然出错<br />
 using namespace std;

 int dp[maxn],a[maxn],p[maxn];   //a[i]表示前i种珍珠的数量总和<br />
 int main()<br />
 {<br />
     int T,min,i,j,c;<br />
     scanf("%d",&amp;T);<br />
     while(T--)<br />
     {<br />
         scanf("%d",&amp;c);<br />
         a[] = ;<br />
         int temp;<br />
         for(i=; i&lt;=c; i++)<br />
         {<br />
             scanf("%d%d",&amp;temp,&amp;p[i]);<br />
             a[i] = a[i-] + temp;<br />
         }<br />
         memset(dp,,sizeof(dp));<br />
         for(i=; i&lt;=c; i++)<br />
         {<br />
             min = inf;<br />
             for(j=; j&lt;i; j++)<br />
             {<br />
                 temp = dp[j] + (a[i]-a[j]+)*p[i];<br />
                 if(temp &lt; min)<br />
                     min = temp;<br />
             }<br />
             dp[i] = min;<br />
         }<br />
         printf("%d\n",dp[c]);<br />
     }<br />
     return ;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o1kz5q.html">PHP基础知识之常量</a>
		</li>
						<li><a href="https://www.batexi.com/a/390lr2o9.html">《HTTP 权威指南》</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q27jpl8.html">windows  batch语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm5d149.html">Codeforces Round &num;352 &lpar;Div&period; 2&rpar; D&period; Robin Hood</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oxygn9.html">用来控制 XML 序列化的属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp1pv59.html">跨服务器查询sql （摘要）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgglvr8.html">IQ调制、整形滤波器与星座映射</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjxl3l8.html">BZOJ3237&colon; &lbrack;Ahoi2013&rsqb;连通图</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m0l2n8.html">python3 常用模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zo57n9.html">ASP&period;NET Core 快速入门（环境篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1kwdmq.html">戏说程序猿之cannot find the object</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2e4lpq.html">发布后就很丢人的随笔&lpar;c&plus;&plus;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9607mmn9.html">使用WinPcap（SharpPcap）实现ARP抓包以实现设备IP修改功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdrxnz9.html">Maven整合Spring3&period;0&plus;Mybatis3&period;2&plus;Struts2&period;3&plus;查找坐标&plus;jar包依赖&lpar;五&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjzm059.html">【BZOJ2671】Calc 数学</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2wpzz9.html">【PyQt5-Qt Designer】浅谈关闭窗口</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv2lnk8.html">接触到的加密算法MD5、SHA1（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjexo28.html">【UOJ Round &num;5】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kxynxq.html">sencha touch 自定义事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4vpolq.html">&lbrack;不屈的复习&rsqb; - 安装Java初始化环境</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96og4g39.html">Codeforces Round &num;343 &lpar;Div&period; 2&rpar; B&period; Far Relative&rsquo;s Problem</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydxoedq.html">shell脚本应用（3）--语法结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydxl22q.html">Devlop Win 8 and Windows Phone App for Microsoft Dynamics CRM</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydxl3jq.html">选择一个 HTTP 状态码不再是一件难事 &ndash; Racksburg</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wveplq.html">AS3 IOC框架Spring Actionscript 的使用总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yw13jq.html">CoreLocation框架的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnz442q.html">团队项目&amp;&num;183&semi;冰球模拟器&mdash;&mdash;cmake 自动化构建系统的配置文件的编写</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdmr3e8.html">使用ajax代替iframe</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0gw0gq.html">&ast;&period;pro、&ast;&period;pri、&ast;&period;prf、&ast;&period;prl等四种文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k14yj79.html">【转】最新基于adt-bundle-windows-x86的android开发环境搭建</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
